import shapely
from axipy import Polygon, Pnt
from osgeo import ogr
from osgeo.ogr import Geometry
from shapely.lib import contains




def createGeometry(spatial_element,cs):
    points=[]
    try:
        item_ordinate=spatial_element['ordinates']['ordinate']
    except:
        item_ordinate=None
        return None
    if item_ordinate is not None:
        for ordinate in spatial_element['ordinates']['ordinate']:
            x=float(ordinate['x'])
            y=float(ordinate['y'])
            points.append(Pnt(y,x))
        polygon=Polygon(points,cs=cs)
        return polygon

def createGeometryGdal(spatial_element):
    points=[]
    try:
        item_ordinate=spatial_element['ordinates']['ordinate']
    except:
        item_ordinate=None
        return None
    if item_ordinate is not None:
        ring = ogr.Geometry(ogr.wkbLinearRing)


        for ordinate in spatial_element['ordinates']['ordinate']:
            x=float(ordinate['x'])
            y=float(ordinate['y'])
            ring.AddPoint(y, x)
        polygon = ogr.Geometry(ogr.wkbPolygon)
        polygon.AddGeometry(ring)
        if not polygon.IsValid():
            jkl=0
        return polygon
class BuildPolygon:
    def __init__(self):
        self.__stack_polygons=[]
    def add(self,geometry:Geometry):
        if geometry is None:
            return
        #geo_shapely=shapely.from_wkb(geometry.ExportToWkb().hex())
        #area=shapely.area(geo_shapely)
        area=geometry.Area()
        self.__stack_polygons.append([geometry,area])
    def getGeometry(self):
        li=self.__stack_polygons
        list_object=sorted(li,key=lambda l:l[1])
        for i in range(len(list_object)-1):
            geo=list_object[i][0]
            if geo is None:
                continue
            is_ok=self.__prepare_polygon(list_object,i,geo)
            if is_ok:
                list_object[i][0]=None
        if len(list_object) == 1:
            return list_object[0][0]
        list_geometry=[]
        for row in list_object:
            if row[0] is None:
                continue
            list_geometry.append(row[0])
        if len(list_geometry)==1:
            return list_geometry[0]

        multipolygon = ogr.Geometry(ogr.wkbMultiPolygon)
        for i,poly in enumerate(list_geometry):

            multipolygon.AddGeometry(poly)
            poly=None
            list_geometry[i]=None
        return multipolygon

    def __prepare_polygon(self,list_polygon,index,geo_base):
        for i in range(index+1,len(list_polygon)):
            geo=list_polygon[i][0]
            if geo is None:
                continue
            if geo.Contains(geo_base):
                #hole_polygons=list(geo.interiors)
                '''
                простое добавление полигонов
                count_geometry=geo.GetGeometryCount()
                new_geometry=ogr.Geometry(ogr.wkbPolygon)
                for i in range(count_geometry):
                    new_geometry.AddGeometry(geo.GetGeometryRef(i))
                temp_line_ring=geo_base.GetGeometryRef(0).GetLinearGeometry()
                new_geometry.AddGeometry(temp_line_ring)
                '''
                #вычитание
                new_geometry=geo.Difference(geo_base)
                geo=None
                list_polygon[i][0]=new_geometry
                #new_polygon=Polygon(geo.exterior,)
                return True
        return False
