import xmltodict


from rosreestrXml.Test.TestCountours.add_tools.helper_geometry import createGeometry, createGeometryGdal, BuildPolygon
from axipy import AxiomaInitLogLevel, init_axioma, CoordSystem, Schema, Attribute, provider_manager, Feature, Geometry

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_source=r"E:\Support\AxiomaTesting\ImprtXml\result (29)\test_contour.xml"
path_tab=r"E:\Support\AxiomaTesting\ImprtXml\result (29)\tab_contours_6.tab"
xml_data=None
cs=None

with open(path_source, 'r') as xml_file:
    xml_data = xml_file.read()
data_dict = xmltodict.parse(xml_data)
cs=CoordSystem.from_prj('8, 9999, 3, 23.57, -140.95, -79.8, 0, -0.35, -0.79, -0.22, 0, 7, 32.03333333333, 0, 1, 1400000, -7011057.628')
schema = Schema(

    Attribute.integer('contour_pp'),
                Attribute.integer('number_pp'),

    coordsystem=cs
)
definition = {
'src': path_tab,
'schema':schema
}
table = provider_manager.create(definition)
id=0
fts=[]
for contour in data_dict['contours']['contour']:
    contour_number=int(contour['number_pp'])

    id=0
    obj_elements=contour['entity_spatial']['spatials_elements']
    obj_spatial_element=obj_elements['spatial_element']
    temp_list=obj_spatial_element
    if not isinstance(obj_spatial_element,list):
        temp_list=[obj_spatial_element]
    jkl=0
    cls_polygons = BuildPolygon()
    for spatiel_element in temp_list:
        if not isinstance(spatiel_element,dict):
            continue
        polygon=createGeometryGdal(spatiel_element)
        if polygon is not None:
            cls_polygons.add(polygon)
    new_geometry=cls_polygons.getGeometry()
    if isinstance(new_geometry,list):
        jkl=0
    new_geometry.SetCoordinateDimension(2)


    axi_geo=Geometry.from_wkb(new_geometry.ExportToWkb(),coordsystem=cs)
    ft=Feature({'contour_pp':contour_number,'number_pp':id},geometry=axi_geo)
    fts.append(ft)
table.insert(fts)

table.commit()
table.close()
print("end")
app.exit()
