
from osgeo import ogr, osr


from rosreestrXml.ui.tools.KPT.cadastral_plan_territory.add_tool import RecordInfoDate
from rosreestrXml.ui.tools.KPT.kptTools.helper_geometry import BuildMultiPolygon, BuildPolygon


def getBObject(tagB_object):
    result=[]
    result.append({'name':'реестровый_номер','value':tagB_object.reg_numb_border})
    result.append({'name': 'код_границы', 'value': tagB_object.type_boundary.code})
    result.append({'name': 'тип_границы', 'value': tagB_object.type_boundary.value})

    return result
class ZoneContourPoints:
    def __init__(self,tagOrdinate,reversXY=False):
        self.__xmlTag=tagOrdinate
        self.__prepare(reversXY)
    def __prepare(self,reversXY):
        if reversXY :
            self.__x = self.__xmlTag.y
            self.__y = self.__xmlTag.x
        else:

            self.__x=self.__xmlTag.x
            self.__y=self.__xmlTag.y
    @property
    def pointXY(self):
        return float(self.__x),float(self.__y)
class ZoneContour:
    def __init__(self,xmlTagContour,reverseXY=False):
        self.__xmlObj=xmlTagContour
        self.__reverseXY=reverseXY
        self.__obj_LinearRings=None
        self.__prepare()
    def __prepare(self):

        spatial_element=None
        try:
            #objSpatial=self.__xmlObj.entity_spatial.spatials_elements.spatial_element[0].ordinates
            spatial_element=self.__xmlObj.entity_spatial.spatials_elements.spatial_element
        except:
            pass
        if spatial_element is None:
            return
        self.__obj_LinearRings=[]
        curent_Ring=None
        for spatial_element_countor in spatial_element:
            if curent_Ring is not None:
                curent_Ring=None
            curent_Ring = ogr.Geometry(ogr.wkbLinearRing)
            for point in spatial_element_countor.ordinates.ordinate:
                #objSpatial.ordinate
                #self.__objPoints.append(ZoneContourPoints(point,self.__reverseXY))
                x,y=ZoneContourPoints(point,self.__reverseXY).pointXY
                curent_Ring.AddPoint(x,y)
            self.__obj_LinearRings.append(curent_Ring)
    @property
    def Geometry(self):
        '''
        geometry = ogr.Geometry(ogr.wkbLinearRing)
        for point in self.__objPoints:
            x,y=point.pointXY
            geometry.AddPoint(x,y)
        '''
        if len(self.__obj_LinearRings)==0:
            return None
        #geometry =ogr.Geometry(ogr.wkbPolygon)
        cls_builder=BuildPolygon()
        for line_ring in self.__obj_LinearRings:
            '''
            isValid=line_ring.IsValid()
            if not isValid:
                line_ring=line_ring.MakeValid()
            '''
            geometry_temp = ogr.Geometry(ogr.wkbPolygon)
            geometry_temp.AddGeometry(line_ring)
            cls_builder.add(geometry_temp)


        return cls_builder.getGeometry()
class ZoneContours:
    def __init__(self,tagB_contours_location,reverseXY=False):
        self.__xmlTag=tagB_contours_location
        self.__reverseXY=reverseXY
        self.__countrs=[]
        self.__prepare()
    def __prepare(self):
        if self.__xmlTag.contours is None:
            return None
        for xml_contour in self.__xmlTag.contours.contour:
            self.__countrs.append(ZoneContour(xml_contour,self.__reverseXY))
            jkl=0
    def getGeometryOld(self):
        type_geometry=ogr.wkbPolygon
        if len(self.__countrs)==0:
            return None
        if len(self.__countrs) ==1:
            geometry = ogr.Geometry(type_geometry)
            geo_lineString=self.__countrs[0].Geometry
            if geo_lineString is None:
                return None
            geometry.AddGeometry(geo_lineString)
            return geometry
        '''
        cls_prepare_polygon=BuildMultiPolygon()
        for countr in self.__countrs:
            geo_lineString = countr.Geometry
            if geo_lineString is None:
                continue
            geometry = ogr.Geometry(ogr.wkbPolygon)
            geometry.AddGeometry(geo_lineString)
            cls_prepare_polygon.add(geometry)
        new_polygons=cls_prepare_polygon.getPolygons()
        geometry_multiPolygon = ogr.Geometry(ogr.wkbMultiPolygon)
        '''
        geometry_multiPolygon = ogr.Geometry(ogr.wkbMultiPolygon)
        for countr in self.__countrs:

            geo_lineString = countr.Geometry
            '''
            is_valid=geo_lineString.IsValid()
            if not is_valid:
                geo_lineString=geo_lineString.MakeValid()
                jkl=0
            '''
            if geo_lineString is None:
                continue
            '''
            shapely_geometry = shapely.from_wkt(geo_lineString.ExportToWkt())
            sh_is_valid = shapely.is_valid(shapely_geometry)
            if not sh_is_valid:
                shapely_geometry_valid=shapely.make_valid(shapely_geometry)
                new_polygon=ogr.CreateGeometryFromWkt(shapely.to_wkt(shapely_geometry_valid))
                geometry_multiPolygon.AddGeometry(new_polygon)
                continue
            '''
            geometry_multiPolygon.AddGeometry(geo_lineString)
            #geometry = ogr.Geometry(ogr.wkbPolygon)
            #geometry.AddGeometry(geo_lineString)
            '''
            if countr_polygon is None:
                continue
            geometry_multiPolygon.AddGeometry(countr_polygon)
            '''
        return geometry_multiPolygon

    def getGeometry(self):

        if len(self.__countrs)==0:
            return None
        if len(self.__countrs) ==1:

            geo_polygon=self.__countrs[0].Geometry
            if geo_polygon is None:
                return None
            return geo_polygon
            '''
            if not geometry.IsValid():
                geometry=geometry.Buffer(0)
            '''
            return geometry
        multipolygon = ogr.Geometry(ogr.wkbMultiPolygon)
        for i, countr in enumerate(self.__countrs):
            poly=countr.Geometry
            if poly is not None:
                if poly.GetGeometryName()=="POLYGON":
                    multipolygon.AddGeometry(poly)
                else:
                    count=poly.GetGeometryCount()
                    for i in range(count):
                        geo_temp=poly.GetGeometryRef(i)
                        multipolygon.AddGeometry(geo_temp)
                        geo_temp=None

            poly = None

        return multipolygon







class Zone:
    def __init__(self,xmlTagZones_and_Territories,cad_number,reverseXY):
        self.__xmlObj=xmlTagZones_and_Territories
        self.__cadNumber=cad_number
        self.__objContours=None

        try:
            self.__objContours=ZoneContours(xmlTagZones_and_Territories.b_contours_location,reverseXY)
        except:
            pass
    @staticmethod

    def struct():
        struct = []

        struct.append({'name': 'дата_регистрации', 'type': ogr.OFTString, 'width': 22})
        struct.append({'name': 'реестровый_номер', 'type': ogr.OFTString, 'width': 20})
        struct.append({'name': 'тип_границы', 'type': ogr.OFTString, 'width': 512})
        struct.append({'name': 'код_границы', 'type': ogr.OFTInteger})
        struct.append({'name': 'тип_зоны', 'type': ogr.OFTString, 'width': 512})
        struct.append({'name': 'код_типа_зоны', 'type': ogr.OFTInteger})
        struct.append({'name': 'номер', 'type': ogr.OFTString, 'width': 100})
        struct.append({'name': 'индекс', 'type': ogr.OFTString, 'width': 100})
        return struct

    def Write(self,layer,str_styleMi=None):
        valRegDate=RecordInfoDate(self.__xmlObj.record_info)
        att = []
        if valRegDate is not None:
            att.append({'name': 'дата_регистрации', 'value': valRegDate.strftime("%Y-%m-%d")})
        b_object_values=getBObject(self.__xmlObj.b_object_zones_and_territories.b_object)
        if len(b_object_values)>0:
            att.extend(b_object_values)
        feature = ogr.Feature(layer.GetLayerDefn())
        if str_styleMi is not None:
            att.append({'name': 'MI_STYLE', 'value': str_styleMi})
        for atr_item in att:
            # print(atr_item['name'])
            # print(atr_item['value'])
            feature.SetField(atr_item['name'], atr_item['value'])
        geoObj = None
        if self.__objContours is not None :
            ''' Формируем геометрию '''
            geoObj=self.__objContours.getGeometry()

        #if geoObj is not None:
        feature.SetGeometry(geoObj)

        layer.CreateFeature(feature)
        jkl=0

class Zones:
    __name = "зоны_територии_границы"
    __nameProcess = "Импорт зон и территорий"
    def __init__(self,tagZones,cadastralNumber,properties):

        if tagZones is None:
            return
        self.__xmlZones=tagZones
        self.__CadastralNumber=cadastralNumber
        self.__properties=properties
        self.__cs_wkt=properties['cs']
        #self.__str_styleMi=properties['zones']['style']
        self.__str_styleMi=""
        self.__listZone=[]

        for itemtagZone in self.__xmlZones.zones_and_territories_record:
            self.__listZone.append(Zone(itemtagZone,self.__CadastralNumber,self.__properties['reverseXY']))
        return
    def setName(self,name_layer):
        self.__name=name_layer

    @property
    def NameLayer(self):
        return self.__name

    @property
    def NameProcess(self):
        return self.__nameProcess
    def CreateLayer(self,ds,createNewLayer=True):
        srs = osr.SpatialReference()
        srs.ImportFromWkt(self.__cs_wkt)
        layer=None
        if not createNewLayer:
            layer=ds.GetLayer(self.__name)
            if layer is not None:
                return layer

        layer = ds.CreateLayer(self.__name, srs, geom_type=ogr.wkbPolygon)
        struct_layer=Zone.struct()
        for fld in struct_layer:
            # create fields
            field_cur = ogr.FieldDefn(fld['name'], fld['type'])
            type_field = fld['type']
            if fld['type'] == ogr.OFTString:
                field_cur.SetWidth(fld['width'])
            layer.CreateField(field_cur)
        if self.__str_styleMi is not None:
            field_cur = ogr.FieldDefn("MI_STYLE", ogr.OFTString)
            field_cur.SetWidth(128)
            layer.CreateField(field_cur)
        return layer
    def Write(self,layer,dbDictionary=None,dbDoc=None):
        if self.__listZone is None:
            return
        ''' Получаем стиль из классификатора'''
        mi_style=dbDictionary.GetStyle('kpt_11_style','zone')
        if mi_style[0] is None:
            print(mi_style[1])
            str_mi_style='Pen (2, 6, 16711680) Brush (1, 16777215, 16777215)'
        else:
            str_mi_style=mi_style[0]
        #layer.StartTransaction()
        for zone in self.__listZone:
            '''
            if dbDoc is not None:
                if dbDoc.IsConnect is False:
                    dbDoc.initDb()
            '''
            zone.Write(layer,str_mi_style)
        #layer.CommitTransaction()
class Municipal_bound:
    def __init__(self,xmlMunicipal_bound,cad_number,reverseXY):
        self.__xmlObj=xmlMunicipal_bound
        self.__cadNumber=cad_number
        self.__objContours=None
        try:
            self.__objContours=ZoneContours(self.__xmlObj.b_contours_location,reverseXY)
        except:
            pass
    @staticmethod

    def struct():
        struct = []

        struct.append({'name': 'дата_регистрации', 'type': ogr.OFTString, 'width': 22})
        struct.append({'name': 'реестровый_номер', 'type': ogr.OFTString, 'width': 20})
        struct.append({'name': 'тип_границы', 'type': ogr.OFTString, 'width': 512})
        struct.append({'name': 'код_границы', 'type': ogr.OFTInteger})
        struct.append({'name': 'тип_зоны', 'type': ogr.OFTString, 'width': 512})
        struct.append({'name': 'код_типа_зоны', 'type': ogr.OFTInteger})
        struct.append({'name': 'номер', 'type': ogr.OFTString, 'width': 100})
        struct.append({'name': 'индекс', 'type': ogr.OFTString, 'width': 100})
        return struct

    def Write(self,layer,str_styleMi=None):
        valRegDate=RecordInfoDate(self.__xmlObj.record_info)
        att = []
        if valRegDate is not None:
            att.append({'name': 'дата_регистрации', 'value': valRegDate.strftime("%Y-%m-%d")})
        b_object_values=getBObject(self.__xmlObj.b_object_municipal_boundary.b_object)
        if len(b_object_values)>0:
            att.extend(b_object_values)
        feature = ogr.Feature(layer.GetLayerDefn())
        if str_styleMi is not None:
            att.append({'name': 'MI_STYLE', 'value': str_styleMi})
        for atr_item in att:
            # print(atr_item['name'])
            # print(atr_item['value'])
            feature.SetField(atr_item['name'], atr_item['value'])
        geoObj = None
        if self.__objContours is not None :
            ''' Формируем геометрию '''
            geoObj=self.__objContours.getGeometry()

        #if geoObj is not None:
        feature.SetGeometry(geoObj)

        layer.CreateFeature(feature)
        jkl=0

class Municipal_boundaries:
    __name='муниципальные_границы'
    __nameProcess = "Импорт муниципальныых границ"
    def __init__(self,tagBoundMunicipal,cadastralNumber,properties):

        if tagBoundMunicipal is None:
            self.__noData=True
            return

        self.__xmlZones=tagBoundMunicipal
        self.__CadastralNumber=cadastralNumber
        self.__properties=properties
        self.__cs_wkt=properties['cs']

        #self.__str_styleMi=properties['municipal']['style']
        self.__str_styleMi=''
        self.__listZone=[]

        for itemtagZone in self.__xmlZones.municipal_boundary_record:
            self.__listZone.append(Municipal_bound(itemtagZone,self.__CadastralNumber,self.__properties['reverseXY']))
        return

    @property
    def NameLayer(self):
        return self.__name

    @property
    def NameProcess(self):
        return self.__nameProcess
    def CreateLayer(self,ds,createNewLayer=True):
        srs = osr.SpatialReference()
        srs.ImportFromWkt(self.__cs_wkt)
        layer=None
        if not createNewLayer:
            layer=ds.GetLayer(self.__name)
            if layer is not None:
                return layer

        layer = ds.CreateLayer(self.__name, srs, geom_type=ogr.wkbPolygon)
        struct_layer=Zone.struct()
        for fld in struct_layer:
            # create fields
            field_cur = ogr.FieldDefn(fld['name'], fld['type'])
            type_field = fld['type']
            if fld['type'] == ogr.OFTString:
                field_cur.SetWidth(fld['width'])
            layer.CreateField(field_cur)
        if self.__str_styleMi is not None:
            field_cur = ogr.FieldDefn("MI_STYLE", ogr.OFTString)
            field_cur.SetWidth(128)
            layer.CreateField(field_cur)
        return layer
    def Write(self,layer,dbDictionary=None,mapCatalog=None):
        if self.__listZone is None:
            return
        ''' Получаем стиль из базы'''

        mi_style = dbDictionary.GetStyle('kpt_11_style', 'municipal_bound')
        if mi_style[0] is None:
            print(mi_style[1])
            str_mi_style = 'Pen (2, 6, 16711680) Brush (1, 16777215, 16777215)'
        else:
            str_mi_style = mi_style[0]
        #layer.StartTransaction()
        for zone in self.__listZone:
            '''
            if dbDoc is not None:
                if dbDoc.IsConnect is False:
                    dbDoc.initDb()
            '''
            zone.Write(layer,str_mi_style)
        mapCatalog.addLayerInfoInMapCataalog(layer,self.__properties['cs_mi'])
        layer=None
