from osgeo import ogr
from osgeo.ogr import Geometry


class BuildMultiPolygon:
    def __init__(self):
        self.__stack_polygons=[]
    def add(self,geometry:Geometry):
        if len(self.__stack_polygons)==0:
            self.__stack_polygons.append(geometry)
            return
        self.is_contain = False
        area_curent=geometry.Area()
        for i,geo in enumerate(self.__stack_polygons):
            self.is_contain=False
            area_base=geo.Area()
            if geo.Intersects(geometry) :
                self.is_contain=True
            else:
                if geo.Contains(geometry):
                    self.is_contain=True
            if self.is_contain:
                if area_curent>area_base:
                    geo_diff=geometry.Difference(geo)
                else:
                    geo_diff=geo.Difference(geometry)
                self.__stack_polygons[i]=geo_diff
                break
        if not self.is_contain:
            self.__stack_polygons.append(geometry)
    def getPolygons(self):
        return self.preparePolygons(self.__stack_polygons)
    def get_temp_polygons(self):
        return self.__stack_polygons
    def clear(self):
        for i in len(self.__stack_polygons):
            self.__stack_polygons[i]=None
        self.__stack_polygons=[]

    def preparePolygons(self,polygons):

        temp_polygons=polygons
        while True:
            temp_polygons,is_contain=self.__recursPoly(temp_polygons)
            if not is_contain:
                break
        return temp_polygons
    def __recursPoly(self,polygons):
        temp_cls=BuildMultiPolygon()
        for geo in polygons:
            if geo is None:
                continue
            temp_cls.add(geo)

        return temp_cls.get_temp_polygons(),temp_cls.is_contain
class BuildPolygon:
    def __init__(self):
        self.__stack_polygons=[]
    def add(self,geometry:Geometry):
        if geometry is None:
            return
        #geo_shapely=shapely.from_wkb(geometry.ExportToWkb().hex())
        #area=shapely.area(geo_shapely)
        area=geometry.Area()
        self.__stack_polygons.append([geometry,area])
    def getGeometry(self):
        li=self.__stack_polygons
        list_object=sorted(li,key=lambda l:l[1])
        for i in range(len(list_object)-1):
            geo=list_object[i][0]
            if geo is None:
                continue
            is_ok=self.__prepare_polygon(list_object,i,geo)
            if is_ok:
                list_object[i][0]=None
        if len(list_object) == 1:
            return list_object[0][0]
        list_geometry=[]
        for row in list_object:
            if row[0] is None:
                continue
            list_geometry.append(row[0])
        if len(list_geometry)==1:
            return list_geometry[0]

        multipolygon = ogr.Geometry(ogr.wkbMultiPolygon)
        for i,poly in enumerate(list_geometry):

            multipolygon.AddGeometry(poly)
            poly=None
            list_geometry[i]=None
        return multipolygon

    def __prepare_polygon(self,list_polygon,index,geo_base):
        for i in range(index+1,len(list_polygon)):
            geo=list_polygon[i][0]
            if geo is None:
                continue
            if geo.Contains(geo_base):
                #hole_polygons=list(geo.interiors)
                '''
                простое добавление полигонов
                count_geometry=geo.GetGeometryCount()
                new_geometry=ogr.Geometry(ogr.wkbPolygon)
                for i in range(count_geometry):
                    new_geometry.AddGeometry(geo.GetGeometryRef(i))
                temp_line_ring=geo_base.GetGeometryRef(0).GetLinearGeometry()
                new_geometry.AddGeometry(temp_line_ring)
                '''
                #вычитание
                new_geometry=geo.Difference(geo_base)
                geo=None
                list_polygon[i][0]=new_geometry
                #new_polygon=Polygon(geo.exterior,)
                return True
        return False






